VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6015
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5355
   LinkTopic       =   "Form1"
   ScaleHeight     =   6015
   ScaleWidth      =   5355
   StartUpPosition =   3  'Windows Default
   Begin MSFlexGridLib.MSFlexGrid flxColors 
      Height          =   2775
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3495
      _ExtentX        =   6165
      _ExtentY        =   4895
      _Version        =   393216
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function SetSysColors Lib "user32" (ByVal nChanges As Long, lpSysColor As Long, lpColorValues As Long) As Long
Private Const COLOR_ACTIVEBORDER = &H8000000A
Private Const COLOR_ACTIVECAPTION = &H80000002
Private Const COLOR_ADJ_MAX = &H80000064
Private Const COLOR_ADJ_MIN = &H8000FF9C
Private Const COLOR_APPWORKSPACE = &H8000000C
Private Const COLOR_BACKGROUND = &H80000001
Private Const COLOR_BTNFACE = &H8000000F
Private Const COLOR_BTNHIGHLIGHT = &H80000014
Private Const COLOR_BTNSHADOW = &H80000010
Private Const COLOR_BTNTEXT = &H80000012
Private Const COLOR_CAPTIONTEXT = &H80000009
Private Const COLOR_GRAYTEXT = &H80000011
Private Const COLOR_HIGHLIGHT = &H8000000D
Private Const COLOR_HIGHLIGHTTEXT = &H8000000E
Private Const COLOR_INACTIVEBORDER = &H8000000B
Private Const COLOR_INACTIVECAPTION = &H80000003
Private Const COLOR_INACTIVECAPTIONTEXT = &H80000013
Private Const COLOR_MENU = &H80000004
Private Const COLOR_MENUTEXT = &H80000007
Private Const COLOR_SCROLLBAR = &H80000000
Private Const COLOR_WINDOW = &H80000005
Private Const COLOR_WINDOWFRAME = &H80000006
Private Const COLOR_WINDOWTEXT = &H80000008

Private ColorNumbers As Collection
Private ColorNames As Collection
Private Sub Form_Load()
Dim r As Integer
Dim c As Integer
Dim new_wid As Single
Dim max_wid As Single
Dim txt As String
Dim rgb_color As Long

    Set ColorNumbers = New Collection
    Set ColorNames = New Collection

    ' Load the color names and numbers.
    ColorNumbers.Add COLOR_ACTIVEBORDER
    ColorNames.Add "COLOR_ACTIVEBORDER"
    ColorNumbers.Add COLOR_ACTIVECAPTION
    ColorNames.Add "COLOR_ACTIVECAPTION"
    ColorNumbers.Add COLOR_ADJ_MAX
    ColorNames.Add "COLOR_ADJ_MAX"
    ColorNumbers.Add COLOR_ADJ_MIN
    ColorNames.Add "COLOR_ADJ_MIN"
    ColorNumbers.Add COLOR_APPWORKSPACE
    ColorNames.Add "COLOR_APPWORKSPACE"
    ColorNumbers.Add COLOR_BACKGROUND
    ColorNames.Add "COLOR_BACKGROUND"
    ColorNumbers.Add COLOR_BTNFACE
    ColorNames.Add "COLOR_BTNFACE"
    ColorNumbers.Add COLOR_BTNHIGHLIGHT
    ColorNames.Add "COLOR_BTNHIGHLIGHT"
    ColorNumbers.Add COLOR_BTNSHADOW
    ColorNames.Add "COLOR_BTNSHADOW"
    ColorNumbers.Add COLOR_BTNTEXT
    ColorNames.Add "COLOR_BTNTEXT"
    ColorNumbers.Add COLOR_CAPTIONTEXT
    ColorNames.Add "COLOR_CAPTIONTEXT"
    ColorNumbers.Add COLOR_GRAYTEXT
    ColorNames.Add "COLOR_GRAYTEXT"
    ColorNumbers.Add COLOR_HIGHLIGHT
    ColorNames.Add "COLOR_HIGHLIGHT"
    ColorNumbers.Add COLOR_HIGHLIGHTTEXT
    ColorNames.Add "COLOR_HIGHLIGHTTEXT"
    ColorNumbers.Add COLOR_INACTIVEBORDER
    ColorNames.Add "COLOR_INACTIVEBORDER"
    ColorNumbers.Add COLOR_INACTIVECAPTION
    ColorNames.Add "COLOR_INACTIVECAPTION"
    ColorNumbers.Add COLOR_INACTIVECAPTIONTEXT
    ColorNames.Add "COLOR_INACTIVECAPTIONTEXT"
    ColorNumbers.Add COLOR_MENU
    ColorNames.Add "COLOR_MENU"
    ColorNumbers.Add COLOR_MENUTEXT
    ColorNames.Add "COLOR_MENUTEXT"
    ColorNumbers.Add COLOR_SCROLLBAR
    ColorNames.Add "COLOR_SCROLLBAR"
    ColorNumbers.Add COLOR_WINDOW
    ColorNames.Add "COLOR_WINDOW"
    ColorNumbers.Add COLOR_WINDOWFRAME
    ColorNames.Add "COLOR_WINDOWFRAME"
    ColorNumbers.Add COLOR_WINDOWTEXT
    ColorNames.Add "COLOR_WINDOWTEXT"

    ' Display the color values.
    flxColors.Rows = ColorNames.Count + 1
    flxColors.Cols = 4
    flxColors.FixedRows = 1
    flxColors.FixedCols = 0
    flxColors.TextMatrix(0, 0) = "Constant"
    flxColors.TextMatrix(0, 1) = "Hex Value"
    flxColors.TextMatrix(0, 2) = "RGB Value"
    flxColors.TextMatrix(0, 3) = "Sample"

    flxColors.Col = 3
    For r = 1 To ColorNames.Count
        ' Display the color name.
        flxColors.TextMatrix(r, 0) = ColorNames(r)

        ' Display the hex color number.
        flxColors.TextMatrix(r, 1) = Hex$(ColorNumbers(r))

        ' Display the hex RGB color value.
        rgb_color = GetSysColor(&HFFFFFF And ColorNumbers(r))
        txt = Hex$(rgb_color)
        txt = String(6 - Len(txt), "0") & txt
        flxColors.TextMatrix(r, 2) = txt

        ' Display a sample.
        flxColors.Row = r
        flxColors.CellBackColor = rgb_color
    Next r

    ' Adjust the column sizes.
    For c = 0 To 3
        max_wid = 0
        For r = 0 To flxColors.Rows - 1
            new_wid = TextWidth(flxColors.TextMatrix(r, c))
            If max_wid < new_wid Then max_wid = new_wid
        Next r
        flxColors.ColWidth(c) = max_wid + 120
    Next c

    flxColors.ColAlignment(1) = flexAlignRightCenter
    flxColors.ColAlignment(2) = flexAlignRightCenter
End Sub

Private Sub Form_Resize()
    flxColors.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


